public class Player {
  float x;
  float y;
  float xv;
  float yv;
  int action;
  int frame;
  int player_size;
  PImage frames[];
  PImage frames2[];
  int timer;
  boolean right;
  public Player() {
    this.x = 0;
    this.y = 0;
    this.xv = 0;
    this.yv = 0;
    this.player_size = 60;
    this.right = true;
    PImage image = loadImage("Chicken.png");
    PImage image2 = loadImage("Chicken2.png");
    frames = new PImage[image.width/player_size];
    frames2 = new PImage[image.width/player_size];
    for (int n = 0; n < frames.length; n++) {
      frames[n] = image.get(n*64, 0, 64, 64);
    }
    for (int n = 0; n < frames2.length; n++) {
      frames2[n] = image2.get(n*64, 0, 64, 64);
    }
  }

  public void update() {
    float oldx = x;
    float oldy = y;
    if (keys[1] == true) xv-=0.52;
    if (keys[2] == true) xv+=0.52;
    if (keys[3] == true && yv == 0) {
      yv-=12;
      jump.trigger();
    }
    if (xv > 0) right = true;
    if (xv < 0) right = false;
    xv/=1.1;
    yv+=0.4;
    y+=yv;
    boolean collided = false;
    for (int stepx = 0; stepx < 2; stepx++) {
      for (int stepy = 0; stepy < 2; stepy++) {
        int cornerx = floor((x+WIDTH/2-player_size/2+player_size*stepx)/tile_size)+1;
        int cornery = floor((y+HEIGHT/2-player_size/2+player_size*stepy)/tile_size)+1;
        if (cornerx < tilemap.map.map_w && cornerx >= 0 && cornery < tilemap.map.map_h && cornery >= 0) {
          if (tilemap.map.map[cornerx][cornery] != -1 && tilemap.map.map[cornerx][cornery] != 2 && tilemap.map.map[cornerx][cornery] != 3) {
            collided = true;
          }
        }
      }
    }
    if (collided == true) {
      y = oldy;
      if(yv < 0) {
        yv = 0.01;
      } else {
        yv = 0;
      }
    }
    x+=xv;
    collided = false;
    for (int stepx = 0; stepx < 2; stepx++) {
      for (int stepy = 0; stepy < 2; stepy++) {
        int cornerx = floor((x+WIDTH/2-player_size/2+player_size*stepx)/tile_size)+1;
        int cornery = floor((y+HEIGHT/2-player_size/2+player_size*stepy)/tile_size)+1;
        if (cornerx < tilemap.map.map_w && cornerx >= 0 && cornery < tilemap.map.map_h && cornery >= 0) {
          if (tilemap.map.map[cornerx][cornery] != -1 && tilemap.map.map[cornerx][cornery] != 2 && tilemap.map.map[cornerx][cornery] != 3) {
            collided = true;
          }
        }
      }
    }
    if (collided == true) {
      x = oldx;
      xv = 0;
    }
    if (xv < 0.1 && xv > -0.1) xv = 0;
    if (xv == 0) {
      frame = 0;
    }
    if(xv != 0) {
      if (millis() - timer >= 125) {
        if (frame == 2) {
          frame = 0;
        } 
        else if (frame == 1) {
          frame = 2;
        } 
        else if (frame == 0) {
          frame = 1;
        } else if (frame == 3) {
          frame = 0;
        }
        timer = millis();
      }
    }
    if (oldy != y) {
      frame = 3;
    }
    if(y > tilemap.map.map_h*tile_size) {
      death();
    }
  }
  
  public void death() {
    deaths++;
    tilemap.loadMap(tilemap.current_level);
  }
}

