public class Portal {
  int x, y;
  boolean open;
  PImage portalopen, portalclosed;
  public Portal(int x, int y) {
    this.x = x;
    this.y = y;
    portalopen = loadImage("PortalOpen.png");
    portalclosed = loadImage("PortalClosed.png");
    open = false;
  }

  public boolean update() {
    if (score >= tilemap.map.totalPoints) {
      open = true;
    }
    if (open) {
      image(portalopen, x-tilemap.camx, y-tilemap.camy);
      if (player.x+WIDTH/2 > x && player.x+WIDTH/2 < x+64 && player.y+HEIGHT/2 > y && player.y+HEIGHT/2 < y+64) {
        return true;
      } else {
        return false;
      }
    } else {
      image(portalclosed, x-tilemap.camx, y-tilemap.camy);
      return false;
    }
  }
}

